#include <ntddk.h>
#include <windef.h>

typedef NTSTATUS (*PSLOOKUPPROCESSBYPROCESSID)
(
 IN ULONG32 ProcessId,
 OUT PEPROCESS *Process
);

typedef NTSTATUS (*PSLOOKUPTHREADBYTHREADID)
(
 IN ULONG32 ThreadId,
 OUT PETHREAD *Thread
);

NTKERNELAPI PEPROCESS IoThreadToProcess(IN PETHREAD Thread);

PSLOOKUPPROCESSBYPROCESSID			PsLookupProcessByProcessId=NULL,Old_PsLookupProcessByProcessId=NULL;
PSLOOKUPTHREADBYTHREADID			PsLookupThreadByThreadId=NULL,Old_PsLookupThreadByThreadId=NULL;

KIRQL f_oldirql;
PEPROCESS ProtectedProcess=NULL;

void Hook(PVOID Func,PVOID NewFunc,PVOID ProxyFunc)
{
	PMDL pMdl;
	PVOID Msct;
	PVOID HookCode;
	ULONG PatchSize;
	BYTE g_HookCode[13]={0x48,0xB8,0,0,0,0,0,0,0,0,0x48,0x89,0x10};
	BYTE g_ProxyCode[13]={0x48,0xB8,0,0,0,0,0,0,0,0,0x48,0x89,0x10};
	PatchSize=GetPatchSize(Func,13);
	*(PULONG64)(g_HookCode+2)=(ULONG64)NewFunc;
	*(PULONG64)(g_ProxyCode+2)=(ULONG64)Func+PatchSize;
	HookCode=ExAllocatePool(NonPagedPool,PatchSize);
	RtlFillMemory(HookCode,PatchSize,0x90);
	RtlFillMemory(ProxyFunc,0x30,0x90);
	RtlCopyMemory(HookCode,g_HookCode,13);
	RtlCopyMemory(ProxyFunc,g_ProxyCode,13);
	RtlCopyMemory((PVOID)((ULONG64)ProxyFunc+PatchSize),g_HookCode,13);
	pMdl=MmCreateMdl(NULL,Func,PatchSize);
	if(pMdl)
	{
		MmBuildMdlForNonPagedPool(pMdl);
		pMdl->MdlFlags=pMdl->MdlFlags|MDL_MAPPED_TO_SYSTEM_VA;
		__try
		{
			MmProbeAndLockPages(pMdl,KernelMode,IoWriteAccess);
		}
		__except(EXCEPTION_EXECUTE_HANDLER)
		{
			IoFreeMdl(pMdl);
		}
		Msct=MmMapLockedPagesSpecifyCache(pMdl,KernelMode,MmWriteCombined,NULL,FALSE,0);
		f_oldirql=KeRaiseIrqlToDpcLevel();
		RtlCopyMemory(Msct,HookCode,PatchSize);
		KeLowerIrql(f_oldirql);
		MmUnmapLockedPages(Msct,pMdl);
		MmUnlockPages(pMdl);
		IoFreeMdl(pMdl);
	}
	ExFreePool(HookCode);
}

void UnHook(PVOID Func,PVOID ProxyFunc)
{
	ULONG PatchSize;
	PMDL pMdl;
	PVOID Msct;
	PatchSize=GetPatchSize(ProxyFunc,12);
	pMdl=MmCreateMdl(NULL,Func,PatchSize);
	if(pMdl)
	{
		MmBuildMdlForNonPagedPool(pMdl);
		pMdl->MdlFlags=pMdl->MdlFlags|MDL_MAPPED_TO_SYSTEM_VA;
		__try
		{
			MmProbeAndLockPages(pMdl,KernelMode,IoWriteAccess);
		}
		__except(EXCEPTION_EXECUTE_HANDLER)
		{
			IoFreeMdl(pMdl);
		}
		Msct=MmMapLockedPagesSpecifyCache(pMdl,KernelMode,MmWriteCombined,NULL,FALSE,0);
		f_oldirql=KeRaiseIrqlToDpcLevel();
		RtlCopyMemory(Msct,ProxyFunc,PatchSize);
		KeLowerIrql(f_oldirql);
		MmUnmapLockedPages(Msct,pMdl);
		MmUnlockPages(pMdl);
		IoFreeMdl(pMdl);
	}
}

NTSTATUS fake_PsLookupProcessByProcessId(IN ULONG32 ProcessId,OUT PEPROCESS *Process)
{
	NTSTATUS st;
	PEPROCESS txps;
	st=Old_PsLookupProcessByProcessId(ProcessId,&txps);
	if(txps==ProtectedProcess)
	{
		st=STATUS_ACCESS_DENIED;
	}
	else
	{
		*Process=txps;
	}
	return st;
}

NTSTATUS fake_PsLookupThreadByThreadId(IN ULONG32 ThreadId,OUT PETHREAD *Thread)
{
	NTSTATUS st;
	PETHREAD txtd;
	PEPROCESS txps;
	st=Old_PsLookupThreadByThreadId(ThreadId,&txtd);
	txps=IoThreadToProcess(txtd);
	if(txps==ProtectedProcess)
	{
		st=STATUS_ACCESS_DENIED;
	}
	else
	{
		*Thread=txtd;
	}
	return st;
}

void StartHook()
{
	//Init Kernel-Exported API
	UNICODE_STRING uniFuncName1;
	UNICODE_STRING uniFuncName2;
	RtlInitUnicodeString(&uniFuncName1,L"PsLookupProcessByProcessId");
	RtlInitUnicodeString(&uniFuncName2,L"PsLookupThreadByThreadId");
	PsLookupProcessByProcessId=MmGetSystemRoutineAddress(&uniFuncName1);
	PsLookupThreadByThreadId=MmGetSystemRoutineAddress(&uniFuncName2);
	//Init Proxy Function
	Old_PsLookupProcessByProcessId=ExAllocatePool(NonPagedPool,0x30);
	Old_PsLookupThreadByThreadId=ExAllocatePool(NonPagedPool,0x30);
	//Start To Hook
	Hook(PsLookupProcessByProcessId,fake_PsLookupProcessByProcessId,Old_PsLookupProcessByProcessId);
	Hook(PsLookupThreadByThreadId,fake_PsLookupThreadByThreadId,Old_PsLookupThreadByThreadId);
}

void StopHook()
{
	//Unhook
	UnHook(PsLookupProcessByProcessId,Old_PsLookupProcessByProcessId);
	UnHook(PsLookupThreadByThreadId,Old_PsLookupThreadByThreadId);
	//Release Proxy Function
	ExFreePool(Old_PsLookupProcessByProcessId);
	ExFreePool(Old_PsLookupThreadByThreadId);
}